# Generated by Django 3.0.2 on 2020-08-19 03:14

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='Category',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=512)),
                ('part_name_template', models.CharField(max_length=512)),
                ('parent', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, to='inventory.Category')),
            ],
        ),
        migrations.CreateModel(
            name='Location',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=512)),
                ('non_local', models.BooleanField()),
                ('parent', models.ForeignKey(null=True, on_delete=django.db.models.deletion.PROTECT, to='inventory.Location')),
            ],
        ),
        migrations.CreateModel(
            name='Manufacturer',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=512)),
                ('website_url', models.URLField()),
            ],
        ),
        migrations.CreateModel(
            name='Order',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('status', models.CharField(choices=[('CART', 'Cart'), ('SUBMITTED', 'Submitted'), ('PROCESSING', 'Processing'), ('COMPLETE', 'Complete'), ('PICKED_UP', 'Picked Up'), ('CANCELLED', 'Cancelled'), ('REJECTED', 'Rejected')], default='CART', max_length=512)),
            ],
        ),
        migrations.CreateModel(
            name='Part',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(blank=True, max_length=512, null=True)),
                ('manufacturer_part_number', models.CharField(blank=True, max_length=512)),
                ('datasheet', models.URLField(blank=True, null=True)),
                ('description', models.TextField(blank=True, null=True)),
                ('category', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='inventory.Category')),
                ('manufacturer', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, to='inventory.Manufacturer')),
            ],
        ),
        migrations.CreateModel(
            name='Supplier',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=512)),
                ('website_url', models.URLField()),
            ],
        ),
        migrations.CreateModel(
            name='Property',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=512)),
                ('category', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='inventory.Category')),
            ],
        ),
        migrations.CreateModel(
            name='PartSupplier',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('supplier_part_number', models.CharField(blank=True, max_length=512)),
                ('supplier_part_url', models.URLField(blank=True)),
                ('price', models.FloatField(null=True)),
                ('part', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='inventory.Part')),
                ('supplier', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='inventory.Supplier')),
            ],
        ),
        migrations.CreateModel(
            name='PartProperty',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('value', models.CharField(max_length=512)),
                ('part', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='inventory.Part')),
                ('property', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='inventory.Property')),
            ],
        ),
        migrations.CreateModel(
            name='PartOrder',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('ordered_qty', models.PositiveIntegerField()),
                ('fulfilled_qty', models.PositiveIntegerField(null=True)),
                ('order', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='inventory.Order')),
                ('part', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='inventory.Part')),
            ],
        ),
        migrations.CreateModel(
            name='PartLocation',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('quantity', models.PositiveIntegerField(null=True)),
                ('barcode', models.CharField(max_length=512)),
                ('location', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='inventory.Location')),
                ('part', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='inventory.Part')),
            ],
        ),
        migrations.AddField(
            model_name='part',
            name='supplier',
            field=models.ManyToManyField(through='inventory.PartSupplier', to='inventory.Supplier'),
        ),
        migrations.CreateModel(
            name='OrderStateChanges',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('last_state', models.CharField(choices=[('CART', 'Cart'), ('SUBMITTED', 'Submitted'), ('PROCESSING', 'Processing'), ('COMPLETE', 'Complete'), ('PICKED_UP', 'Picked Up'), ('CANCELLED', 'Cancelled'), ('REJECTED', 'Rejected')], max_length=512)),
                ('next_state', models.CharField(choices=[('CART', 'Cart'), ('SUBMITTED', 'Submitted'), ('PROCESSING', 'Processing'), ('COMPLETE', 'Complete'), ('PICKED_UP', 'Picked Up'), ('CANCELLED', 'Cancelled'), ('REJECTED', 'Rejected')], max_length=512)),
                ('timestamp', models.DateTimeField()),
                ('changed_by', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, to=settings.AUTH_USER_MODEL)),
                ('order', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='inventory.Order')),
            ],
        ),
        migrations.AddField(
            model_name='order',
            name='parts',
            field=models.ManyToManyField(through='inventory.PartOrder', to='inventory.Part'),
        ),
    ]
